package cn.com.qmth.examcloud.exchange.inner.api.provider;

import java.io.IOException;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;
import org.springframework.web.multipart.MultipartFile;

import cn.com.qmth.examcloud.commons.exception.StatusException;
import cn.com.qmth.examcloud.commons.util.AES;
import cn.com.qmth.examcloud.exchange.inner.api.UpyunCloudService;
import cn.com.qmth.examcloud.exchange.inner.api.request.PutFileReq;
import cn.com.qmth.examcloud.exchange.inner.api.response.PutFileResp;
import cn.com.qmth.examcloud.exchange.inner.service.UpyunService;
import cn.com.qmth.examcloud.exchange.inner.service.bean.UpyunPathEnvironmentInfo;
import cn.com.qmth.examcloud.web.config.SystemConfig;
import cn.com.qmth.examcloud.web.support.ControllerSupport;

/**
 * Upyun服务
 *
 * @author WANGWEI
 * @date 2018年11月21日
 * @Copyright (c) 2018-? http://qmth.com.cn All Rights Reserved.
 */
@RestController
@RequestMapping("${$rmp.cloud.exchange.inner}/upyun")
public class UpyunCloudServiceProvider extends ControllerSupport implements UpyunCloudService {

	private static final long serialVersionUID = -6911335293165224994L;

	@Autowired
	UpyunService upyunService;

	@Autowired
	SystemConfig systemConfig;

	AES aes = new AES();

	@PostMapping("putFile")
	@Override
	public PutFileResp putFile(PutFileReq req) {
		String fileSuffix = req.getFileSuffix();
		Long rootOrgId = req.getRootOrgId();
		Long userId = req.getUserId();
		String siteId = req.getSiteId();
		MultipartFile mf = req.getFile();

		UpyunPathEnvironmentInfo env = new UpyunPathEnvironmentInfo();
		env.setRootOrgId(String.valueOf(rootOrgId));
		env.setUserId(String.valueOf(userId));
		env.setFileSuffix(fileSuffix);

		String url = null;
		try {
			url = upyunService.writeFile(siteId, env, mf.getInputStream());
		} catch (IOException e) {
			throw new StatusException("005001", "fail to write to upyun", e);
		}
		url = aes.encrypt(url);

		PutFileResp resp = new PutFileResp();
		resp.setUrl(url);
		return resp;
	}

}
